/************************************************************************
 *                                                                      *
 *  Program package         U F F                                       *
 *                                                                      *
 *  Version   1.2                                                       *
 *  Date:     Fri Nov  1 11:11:57 1996                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'tr@uninova.pt'.                                     *
 *                                                                      *
 ************************************************************************/


#include <stdio.h>
#include <string.h>
#include "def.h"
#include "unldef.h"

extern str20 pr;
extern bool verbose;
extern int N;
extern Pixel **P;
extern int nrFeat;
extern str100 featFile;


bool trace = FALSE;
str100 dataDir;
FILE *featData = NULL;


#ifdef DIRECT
#undef DIRENT
#endif


#ifdef DIRENT
#include <dirent.h>
static struct dirent *dp = NULL;
#else
#include <sys/dir.h>
static struct direct *dp = NULL;
#endif

static DIR *dir = NULL;


void open_directory( patDir )
char *patDir;
{
 dir = opendir( patDir );
}


void close_directory()
{
 closedir( dir );
 dir = NULL;
}


bool err_directory()
{
 return( dir == NULL );
}


bool next_directory( dirName, fileName )
char *dirName;	/* here without function */
char *fileName;
{
 do
 {
   dp = readdir( dir );
   if( dp == NULL )
     return( FALSE );
 }
 while( dp->d_name[0]=='.' || (dp->d_name[0]=='.' && dp->d_name[1]=='.') );
 /* printf("%sFinding: %s\n", pr, dp->d_name ); /**/
 strcpy( fileName, dp->d_name );
 return( TRUE ); 
}


#define MAXFILES 1000

int nrFiles;

str100 patDir, dataFile;
static str100 sampleFile;
static str80 linebuf, buf;
static char wheel[] = "|/-\\";
static bool ascii_file = FALSE;

#ifdef NON_UNIX
static char slash = '\\';
#endif
#ifdef UNIX
static char slash = '/';
#endif


void get_pat()
{
 int i, offset = 1;
 bool found;
 str100 fileName, dirName;

 strcpy( patDir, dataDir );
 if( verbose )
   { fprintf( stderr, "%sSearching image files in %s\n", pr, patDir ); }
 /* first count the files */
 open_directory( patDir );
 if( err_directory() )
   { printf("%sCannot open directory %s - exit ...", pr, patDir );
     gets(linebuf); exit(1); }

 nrFiles = 0;
 strcpy( dirName, patDir );
 if( patDir[strlen(patDir)-1] != slash )
 {
   patDir[strlen(patDir)] = slash;
   patDir[strlen(patDir)+1] = '\0';
 }

 i = strlen( patDir ) - 2;
 while( patDir[i] != slash && i > 0 )
   i--;
 if( i == 0 )
   offset = 0; 
 strncpy( dirName, &(patDir[i+offset]), strlen(&(patDir[i+offset]))-1 );
 dirName[strlen(&(patDir[i+offset]))-1] = '\0';

 do
 {
   found = next_directory( patDir, fileName );
   if( found )
     nrFiles++;
 }
 while( found );
 close_directory();
 if( verbose )
   printf("%sFound %d files\n", pr, nrFiles );

 if( nrFiles <= 0 || nrFiles > MAXFILES )
   { printf("%sNumber of classes invalid! Exitus...\n", pr ); exit(1); }


  /* drop all UNL Fourier Feature values to a data file */

 featData = fopen( featFile, f_open_text_w );
 if( featData == NULL )
    { fprintf(stderr,"%sCould not open \"%s\" for writing !!!\n",
	pr, featFile ); exit(1); }
 printf("%sDumping UNL Fourier Features to %s\n", pr, featFile );
 /* write name of the class */
 fprintf( featData, "%s\n", dirName );

 /* write the dimension of the feature vector */
 fprintf( featData, "%d\n", nrFeat );
 /* number of samples */
 fprintf( featData, "%d\n", nrFiles );

 /* scan through the files */
 open_directory( patDir );
 i = 0;
 do
 {
   found = next_directory( patDir, fileName );
   if( found )
   {
     strcpy( sampleFile, patDir ); 
     strcat( sampleFile, fileName );
     if( verbose )
       printf("%sScanning file: %s\n", pr, sampleFile );
     else
     {
       printf("%sPatterns to go: %d   \r", pr, nrFiles - i - 1 );
       fflush( stdout );
     }
     clearPattern( P );
     pbm2pat( sampleFile, N, P );
     calcFeat( P );
     dumpFeat();
     i++;
     if( trace ) {NL; WAIT;}
   }
 }
 while( found );
 printf("\n");
 close_directory();
 fclose( featData );
}
