/************************************************************************
 *                                                                      *
 *  Program package         U F F                                       *
 *                                                                      *
 *  Version   1.2                                                       *
 *  Date:     Fri Nov  1 11:11:55 1996                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'tr@uninova.pt'.                                     *
 *                                                                      *
 ************************************************************************/



#include "def.h"
#include "unldef.h"

extern int N;
extern int feature_type;

bool X = TRUE;

static int Y = 150, offsetX;

#define PATT_START      20

static void drawStaticAreas()
{
 offsetX = MAX( 30, N-50 );
 /* Draw the frames of the images */
 tgi_rectangle( PATT_START-1,      Y, N+1, N+1 );
 if( feature_type == UFF )
   tgi_rectangle( PATT_START-1+N+60, Y, N+1, N+1 );

 /* LOGO */
 tgi_string( offsetX, Y/4,    "           UNIVERSIDADE NOVA DE LISBOA" );
 tgi_string( offsetX, Y/4+15, "        Faculdade de Ciencias e Tecnologia" );
 tgi_string( offsetX, Y/4+30, "           Intelligent Robotics Center" );
 if( feature_type == UFF )
   tgi_string( offsetX, Y/4+45, "                UNL -  TRANSFORM" );
 if( feature_type == FOURIER_DESCRIPTORS )
   tgi_string( offsetX, Y/4+45, "                FOURIER DESCRIPTORS" );
 tgi_string( offsetX, Y/4+60,"(c) Copyright Thomas W. Rauber");

 /* Attach text */
 tgi_string( PATT_START+N+6, Y+N, "X" );
 tgi_string( PATT_START, Y-5, "Y" );
 tgi_string( PATT_START, Y+N+18, "Cartesian" );
 tgi_string( PATT_START, Y+N+18+15, "pattern" );

 if( feature_type == UFF )
 {
   tgi_string( PATT_START+N+6+N+60, Y+N, "R" );
   tgi_string( PATT_START+N+60, Y-5, "theta" );
   tgi_string( PATT_START+N+60, Y+N+18, "UNL transformed" );
   tgi_string( PATT_START+N+60, Y+N+18+15, "pattern" );
 }
 tgi_flush();
}

void initDisplay()
{
 if( X )
 {
   tgi_init();
   tgi_clearWin();
   drawStaticAreas();
 }
}


void closeDisplay()
{
 if( X )
 {
   tgi_close();
 }
}


void DisplayPats( P, TP )
Pixel **P, **TP;
{
 int x,y;
 
 if( X )
 {
   /* Draw the pattern and its transformation */
   /* first clear dynamic areas */
   tgi_ClearArea( PATT_START, Y+1, N, N );
   tgi_ClearArea( PATT_START+N+60, Y+1, N, N );

   drawStaticAreas(); /**/
   for( x = 0; x < N; x++ )
     for( y = 0; y < N; y++ ) 
     {
       if( P[x][y] )  tgi_pixel( PATT_START+x, Y+N-y );
       if( TP[x][y] )  tgi_pixel( PATT_START+x+N+60, Y+N-y );
     }
   tgi_flush();
 }
}
