/************************************************************************
 *                                                                      *
 *  Program package         U F F                                       *
 *                                                                      *
 *  Version   1.2                                                       *
 *  Date:     Fri Nov  1 11:11:57 1996                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'tr@uninova.pt'.                                     *
 *                                                                      *
 ************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include "def.h"
#include "unldef.h"

extern str20 pr;
extern bool verbose;
extern bool X;
extern int feature_type;
extern bool outAscii;
extern int N;
extern str100 featNameFile;
extern FILE *featData;
extern int nrFeat;
extern int FD_buf_len;
extern int FD_fraction;
extern float *FD;


/*
 * Limit the Fourier Descriptors only to the lower frequencies, i. e.
*/
static bool bounding_condition( u, uchr )
int u, *uchr;
{
 bool valid_fd, lower, upper;
 int margin, uabs;

 margin = FD_buf_len / FD_fraction / 2;
 lower = u < margin;
 upper = u >= FD_buf_len - margin;

 valid_fd = u != 0 && u != 1;		/* ignore the first two */
 valid_fd = valid_fd && ( lower || upper );

 if( lower ) *uchr = u;
 if( upper ) *uchr = u - FD_buf_len;

 return( valid_fd );
}



void gen_fd_feat_desc()
{
 FILE *fd = NULL;
 int i = 0, u, uchr;

 fd = fopen( featNameFile, f_open_text_w );
 if( fd == NULL )
    { fprintf(stderr,"%sCould not open %s for writing !!!\n",
	pr, featNameFile ); exit(1); }
 printf("%sDumping feature name description to %s\n", pr, featNameFile  );

 
 for( u = 0; u < FD_buf_len; u++ )
   if( bounding_condition( u, &uchr ) )
     i++;
 nrFeat = i;
 fprintf( fd, "%d\n", nrFeat );

 for( u = 0; u < FD_buf_len; u++ )
 {
   if( bounding_condition( u, &uchr ) )
     fprintf( fd, "FD_%d\n", uchr );
 }
 fclose( fd );
}


#define NEXTLINE 10
void dumpFeat_FD()
{
 int i, ichr, nr = 1;
 float fd;

 for( i = 0; i < FD_buf_len; i++ )
 {
   if( bounding_condition( i, &ichr ) )
   {
     fd = FD[i];
     /* printf("fd[%3d]=%0.5f \n", i, fd ); /**/
     if( outAscii )
     {
       fprintf( featData, "%f ", fd );
       if( (nr % NEXTLINE) == 0 )
         fprintf( featData, "\n");
       nr++;
     }
     else
       fwrite( &fd, sizeof(float), 1, featData );
     }
 }
 if( outAscii && !(((nr-1)% NEXTLINE) == 0) )
   fprintf( featData, "\n");
}
