/************************************************************************
 *                                                                      *
 *  Program package         U F F                                       *
 *                                                                      *
 *  Version   1.2                                                       *
 *  Date:     Fri Nov  1 11:11:54 1996                                  *
 *                                                                      *
 *  NOTE: This program package is copyrighted in the sense that it      *
 *  may be used for scientific purposes. The package as a whole, or     *
 *  parts thereof, cannot be included or used in any commercial         *
 *  application without written permission granted by the author.       *
 *  No programs contained in this package may be copied for commercial  *
 *  distribution.                                                       *
 *                                                                      *
 *  All comments  concerning this program package may be sent to the    *
 *  e-mail address 'tr@uninova.pt'.                                     *
 *                                                                      *
 ************************************************************************/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "def.h"
#include "unldef.h"

extern int N;

static char x(i)
int i;
{ if( i ) return('*'); else return(' '); }

static int peepMask( p1, p2, p3, p4, p5, p6, p7, p8, p9 )
int p1, p2, p3, p4, p5, p6, p7, p8, p9;
{ printf(" _____\n");
  printf(" |%c%c%c|\n",x(p9),x(p2),x(p3));
  printf(" |%c%c%c|\n",x(p8),x(p1),x(p4));
  printf(" |%c%c%c|\n",x(p7),x(p6),x(p5));
  printf(" -----\n");
}

/*>>>>>>>>>>-----------------------------<<<<<<<<<<<<<<<*/
/*							*/
/*       ensures d-connectivity between pixels		*/
/*	see Gonzalez / Wintz : Digital Image Processing	*/
/*          II. edition page 30, Addison Wesley		*/
/*							*/
/*>>>>>>>>>>------------------------------<<<<<<<<<<<<<<*/

static int getMCond2( p2, p4, p6, p8 )
int p2, p4, p6, p8;
{ int MCond= FALSE; 
 
  if( p2 && p4 ) MCond= TRUE;
  else {
   if( p4 && p6 ) MCond= TRUE;
    else {
     if( p6 && p8 ) MCond= TRUE;
      else {
       if( p8 && p2 ) MCond= TRUE;
      }
    }
  }
  return( MCond ); 
}

static int getMCond3( p2, p3, p4, p5, p6, p7, p8, p9 )
int p2, p3, p4, p5, p6, p7, p8, p9;
{ int MCond= FALSE; 
 
  if( p2 && p4 && (p5 || p9) ) MCond= TRUE;
  else {
   if( p4 && p6 && (p3 || p7) ) MCond= TRUE;
    else {
     if( p6 && p8 && (p5 || p9) ) MCond= TRUE;
      else {
       if( p8 && p2 && (p3 || p7) ) MCond= TRUE;
      }
    }
  }
  return( MCond ); 
}

/* use Lookup-tables to look up m-connectivity condition */
static Pixel mConnectLookup[2][2][2][2][2][2][2][2][2];

void initmConnectLookup()
{int p1, p2, p3, p4, p5, p6, p7, p8, p9;
 int Np1, MCond;

 for( p1= 0; p1< 2; p1++ )
   for( p2= 0; p2< 2; p2++ )
     for( p3= 0; p3< 2; p3++ )
       for( p4= 0; p4< 2; p4++ )
         for( p5= 0; p5< 2; p5++ )
           for( p6= 0; p6< 2; p6++ )
             for( p7= 0; p7< 2; p7++ )
               for( p8= 0; p8< 2; p8++ )
                 for( p9= 0; p9< 2; p9++ ) {

                   Np1= p2+p3+p4+p5+p6+p7+p8+p9;
                   MCond= FALSE;
                   if( Np1 == 2 )  /* investigate special case */
                     MCond= getMCond2(p2, p4, p6, p8 );
                   if( Np1 == 3 )  /* investigate special case */
                     MCond= getMCond3( p2, p3, p4, p5, p6, p7, p8, p9 );
                   mConnectLookup[p1][p2][p3][p4][p5][p6][p7][p8][p9]=
                        (Pixel)( p1 && !MCond );
                 }
}



/* 
 *  NORMAL CASE : PATTERN IN CARTESIAN COORDINATES
 */
void m_connectivity( P )
Pixel **P;
{ int x, y;
 int xMin, xMax, yMin, yMax;
 int nrPointsDeleted, nrPasses=0, Np1, mconnected= FALSE;
 int p1, p2, p3, p4, p5, p6, p7, p8, p9;
 int MCond;
 Pixel pix;

 /* calculate the bounding box of the binary pattern */
 xMin= N-1; xMax= 0; yMin= N-1; yMax= 0;
 for( y=0; y< N; y++ )
   for( x=0; x< N; x++ )
     if( P[x][y] )
     {
       if( x < xMin ) xMin= x;
       if( y < yMin ) yMin= y;
       if( x > xMax ) xMax= x;
       if( y > yMax ) yMax= y;
     }
 if( xMin < 2 ) xMin= 2; if( yMin < 2 ) yMin= 2;
 if( xMax > N-3 ) xMax= N-3; if( yMax > N-3 ) yMax= N-3;

 while( !mconnected ) {
  nrPointsDeleted= 0;

  /* scan the pattern with the 3x3 mask (8-neighborhood) */
  for(y= yMin-2; y<= yMax; y++)
    for(x= xMin-2; x<= xMax; x++) {

      pix = mConnectLookup[P[x+1][y+1]][P[x+1][y+2]][P[x+2][y+2]][P[x+2][y+1]][P[x+2][y]][P[x+1][y]][P[x][y]][P[x][y+1]][P[x][y+2]]; 
      if( P[x+1][y+1] != pix ) nrPointsDeleted++;

      /* if( P[x+1][y+1] != pix )  { 
         peepMask( P[x+1][y+1], P[x+1][y+2], P[x+2][y+2], P[x+2][y+1], P[x+2][y], P[x+1][y], P[x][y], P[x][y+1], P[x][y+2] );
         printf("M_CONNECT  ---> Point will be del.\n"); DBG;
      }; /**/

      P[x+1][y+1] = pix;
    }/* for */

  mconnected= nrPointsDeleted== 0; 
  nrPasses++;
  /* printf("PASS %d\n",nrPasses); /**/
 }/*while*/  
}

/* 
 *  SPECIAL CASE : PATTERN IN POLAR COORDINATES
 *  close the loop between smallest and biggest angle : wrap around
 */
void m_connectivity_Polar( P )
Pixel **P;
{ int x, y;
 int nrPointsDeleted, nrPasses=0, Np1, mconnected= FALSE;
 Pixel pix;
 Pixel *MaxAngle = NULL, *MinAngle = NULL;

 MaxAngle = (Pixel*) malloc( N * sizeof(Pixel) ); CHKPTR( MaxAngle );
 MinAngle = (Pixel*) malloc( N * sizeof(Pixel) ); CHKPTR( MinAngle );

 while( !mconnected ) {
   nrPointsDeleted= 0;

   /* close the loop: wrap pattern around theta */
   for( x= 0; x< N; x++ ) MinAngle[x] = P[x][N-1];
   for( x= 0; x< N; x++ ) MaxAngle[x] = P[x][0];

   /* Special Case : first row */

   for( x = 1; x< N-1; x++ ) {
     pix = mConnectLookup[P[x][0]][P[x][1]][P[x+1][1]][P[x+1][0]][MinAngle[x+1]][MinAngle[x]][MinAngle[x-1]][P[x-1][0]][P[x-1][1]];
     if( P[x][0]  != pix ) nrPointsDeleted++;
     P[x][0] = pix;
   }


   /* Last row */

   for( x= 1; x< N-1; x++ ) {
     pix = mConnectLookup[P[x][N-1]][MaxAngle[x]][MaxAngle[x+1]][P[x+1][N-1]][P[x+1][N-2]][P[x][N-2]][P[x-1][N-2]][P[x-1][N-1]][MaxAngle[x-1]];
     if( P[x][N-1]  != pix ) nrPointsDeleted++;
     P[x][N-1] = pix;
   }


   /* lower left corner */
   pix = mConnectLookup[P[0][0]][P[0][1]][P[1][1]][P[1][0]][OFF][OFF][OFF][OFF][OFF];
   if( P[0][0] != pix ) nrPointsDeleted++;
   P[0][0] = pix;

   /* upper left corner */
   pix = mConnectLookup[P[0][N-1]][OFF][OFF][P[1][N-1]][P[1][N-2]][P[0][N-2]][OFF][OFF][OFF];
   if( P[0][N-1] != pix ) nrPointsDeleted++;
   P[0][N-1] = pix;

   /* rest of first column */
   for( y= 1; y< N-2; y++ ) {
     pix = mConnectLookup[P[0][y]][P[0][y+1]][P[1][y+1]][P[1][y]][P[1][y-1]][P[0][y-1]][OFF][OFF][OFF];
     if( P[0][y] != pix ) nrPointsDeleted++;
     P[0][y] = pix;
   }

   /* lower right corner */
   pix = mConnectLookup[P[N-1][0]][P[N-1][1]][OFF][OFF][OFF][OFF][OFF][P[N-2][0]][P[N-2][1]];
   if( P[N-1][0] != pix ) nrPointsDeleted++;
   P[N-1][0] = pix;

   /* upper right corner */
   pix = mConnectLookup[P[N-1][N-1]][OFF][OFF][OFF][OFF][P[N-1][N-2]][P[N-2][N-2]][P[N-2][N-1]][OFF];
   if( P[N-1][N-1] != pix ) nrPointsDeleted++;
   P[N-1][N-1] = pix;

   /* rest of last column */
   for( y= 1; y< N-2; y++ ) {
     pix = mConnectLookup[P[N-1][y]][P[N-1][y+1]][OFF][OFF][OFF][P[N-1][y-1]][P[N-2][y-1]][P[N-2][y]][P[N-2][y+1]];
     if( P[N-1][y] != pix ) nrPointsDeleted++;
     P[N-1][y] = pix;
   }

   
   /* rest of the pattern */
   for(y= 0; y< N-2; y++)
     for(x= 0; x< N-2; x++) {

       pix = mConnectLookup[P[x+1][y+1]][P[x+1][y+2]][P[x+2][y+2]][P[x+2][y+1]][P[x+2][y]][P[x+1][y]][P[x][y]][P[x][y+1]][P[x][y+2]]; 
      if( P[x+1][y+1] != pix ) nrPointsDeleted++;

/* if( P[x+1][y+1] != pix )  { 
         peepMask( P[x+1][y+1], P[x+1][y+2], P[x+2][y+2], P[x+2][y+1], P[x+2][y], P[x+1][y], P[x][y], P[x][y+1], P[x][y+2] );
         printf("M_CONNECT  ---> Point will be del.\n");
      }
/* */

       P[x+1][y+1] = pix;
     }/* for */

   mconnected= nrPointsDeleted== 0;
   nrPasses++;
   /* printf("PASS %d\n",nrPasses); /**/
 }/*while*/
 FREE( MinAngle ); FREE( MaxAngle );
}
